Attribute VB_Name = "basRobot91"
' -------------------------------------------------------------------------
'
'  basRobot91(Robot91.BAS)                           Ulrich Mller   3.5.98
'                                                    Dell XPS P90 VB4-16/32
'                                                             dto.      VB5
'  Fischertechnik Profi-Robotor 91 : Public Variable
'      Public Routinen, Roboter-Programme
'
' Die wesentlichen Betriebsprogramme sind :
'
' - Bringe            : Gegriffenes Teil auf vorgegebene Position bringen                  bringen
' - GreiferAuf        : ffnen des Greifer bis zum Anschlag
' - GreiferZu         : Schlieen des Greifers auf "Verdacht" : Anzahl
'                       Impulse
' - Heben             : Armheben bis zur Endlage
' - Hole              : Teil auf vorgegebener Postion greifen
' - Init              : Fahren auf Ausgangsposition
' - PosV6             : Turm auf vorgegebene Position drehen
' - RobotDemo         : Demo Programm fr Robot91 : einfacher
'                       Bewegungszyklus Hole - Bringe nach Profi-Robot
' - Senken            : Senken des Arm auf "Verdacht" : Anzahl Impulse
'
' -------------------------------------------------------------------------

Option Explicit

' --- Interface Konstanten ---

Public Const cComNr = 1             ' Nr des COM/LPT-Ports
Public Const cRLinks = 1            ' Motor nomineller Linkslauf
Public Const cRRechts = 2           ' Motor nomineller Rechtslauf
Public Const cRAus = 0              ' Motor Abschalten
Public Const cRReset = 8            ' Reset-Eingang
Public Const cRNotHalt = 8          ' NotHalt-Eingang

' --- Farbcodierung ---

Public Const cFarbeAus = &H8000000F
Public Const cFarbeAusH = &HE0E0E0
Public Const cFarbeEin = &HFF00&
Public Const cFarbeFehler = &HFF8&
Public Const cFarbeEnde = &H80C0FF

' --- Turm ---

Public Const cRTurmMotor = 1
Public Const cRTurmRechts = cRRechts
Public Const cRTurmLinks = cRLinks
Public Const cRTurmEnde = 6
Public Const cRTurmImpuls = 2

' --- Arm ---

Public Const cRArmMotor = 2
Public Const cRArmAuf = cRRechts
Public Const cRArmAb = cRLinks
Public Const cRArmEnde = 3
Public Const cRArmImpuls = 5

' --- Greifer ---

Public Const cRGreiferMotor = 3
Public Const cRGreiferAuf = cRRechts
Public Const cRGreiferZu = cRLinks
Public Const cRGreiferEnde = 1
Public Const cRGreiferImpuls = 4

' --- Public Variable ---

Public ft As frmFishFace             ' --- Kurzschreibweise zum Ansprechen
                                     '     von Funktionen des FishFace
Public mf As frmRobotMain            ' --- Kurzschreibweise fr RobotMain
Public ProgrammNr%                   ' Nr des akt. laufenden Programms
' ----- Positionen : Zhlung erfolgt in den entsprechenden Programmen
'       bei Stellbewegungen ber das Display wird ggf. 'steht' angezeigt
Public TurmPosition%                 ' Turmposition in Anzahl Impulsen
                                     ' Position Rechts = 0
Public ArmPosition%                  ' Armposition in Anzahl Impulsen
                                     ' Position Oben = 0
Public GreiferPosition%              ' Greiferposition in Anzahl Impulsen
                                     ' Position Offen = 0

' --- Programmdaten ---

Public GreiferImpulseD%       ' Anzahl Schlieimpulse
Public GreiferHheD%          ' Anzahl Senkenimpulse
Public HolePositionD%         ' Anzahl Impulse von rechts zur HolePosition
Public BringePositionD%       ' Anzahl Impulse von rechts zur BringePosition
Public WiederholenD As Boolean  ' Wiederholen des Ablaufzyklus


Private Sub Bringe(PosW%)

' --- Gegriffenes Teil auf vorgegebene Position (PosV6) bringen ---

  If ft.GetInput(cRGreiferEnde) Then
    mf!lblStatus = "Bringen is nich"
    Exit Sub
  Else
    mf!lblStatus = "Auftrag Bringen gestartet"
    mf!lblStatus.BackColor = cFarbeEin
    PosV6 PosW
    Senken GreiferHheD
    GreiferAuf
    Heben
    mf!lblStatus = "Auftrag Bringen beendet"
    mf!lblStatus.BackColor = cFarbeEnde
  End If
  
End Sub


Private Sub GreiferAuf()

' --- ffnen des Greifer bis zum Anschlag ---

  If Not ft.GetInput(cRGreiferEnde) Then
    mf!lblGAction = "ffnet"
    mf!lblGAction.BackColor = cFarbeEin
    ft.SetMotor cRGreiferMotor, cRGreiferAuf
    Do
    Loop Until ft.GetInput(cRGreiferEnde)
    ft.SetMotor cRGreiferMotor, cRAus
    mf!lblGAction = "offen"
    mf!lblGAction.BackColor = cFarbeEnde
    GreiferPosition = 0
  End If
  
End Sub

Private Sub GreiferZu(GZu%)

' --- Schlieen des Greifers auf "Verdacht" : Anzahl Impulse cRGreiferSCnt

  mf!lblGAction = "schliet"
  mf!lblGAction.BackColor = cFarbeEin
  ft.SetMotor cRGreiferMotor, cRGreiferZu
  ft.WaitForChange cRGreiferImpuls, GZu
  ft.SetMotor cRGreiferMotor, cRAus
  GreiferPosition = GreiferPosition + GZu
  mf!lblGAction = Format(GreiferPosition, "000")
  mf!lblGAction.BackColor = cFarbeAusH
  
End Sub

Private Sub Heben()

' --- Armheben bis zur Endlage ---

  If Not ft.GetInput(cRArmEnde) Then
    mf!lblAAction = "hebt"
    mf!lblAAction.BackColor = cFarbeEin
    ft.SetMotor cRArmMotor, cRArmAuf
    Do
    Loop Until ft.GetInput(cRArmEnde)
    ft.SetMotor cRArmMotor, cRAus
    mf!lblAAction = "oben"
    mf!lblAAction.BackColor = cFarbeEnde
    ArmPosition = 0
  End If
  
End Sub

Private Sub Hole(PosW%)

' --- Teil auf vorgegebener Position greifen ---

  If ft.GetInput(cRGreiferEnde) Then
    mf!lblStatus = "Auftrag Holen gestartet"
    mf!lblStatus.BackColor = cFarbeEin
    PosV6 PosW
    Senken GreiferHheD
    GreiferZu GreiferImpulseD
    Heben
    mf!lblStatus = "Auftrag Holen beendet"
    mf!lblStatus.BackColor = cFarbeEnde
  Else
    mf!lblStatus = "Holen is nich"
    Exit Sub
  End If
  
End Sub


Private Sub InitM()

' --- Robot91 : Fahren auf Ausgangsposition ---
    
  Heben
  GreiferAuf

  If Not ft.GetInput(cRTurmEnde) Then
    mf!lblTAction = "dreht"
    mf!lblTAction.BackColor = cFarbeEin
    ft.SetMotor cRTurmMotor, cRTurmRechts
    Do
    Loop Until ft.GetInput(cRTurmEnde)
    ft.SetMotor cRTurmMotor, cRAus
    mf!lblTAction = "rechts"
    mf!lblTAction.BackColor = cFarbeEnde
    TurmPosition = 0
  End If
  mf!lblStatus = "Robot91 hat Grundstellung erreicht"
  mf!lblStatus.BackColor = cFarbeEnde
  
End Sub

Private Sub PosV6(PosW%)

' --- Turm auf vorgegebene Position drehen ---

  mf!lblTAction = "dreht"
  mf!lblTAction.BackColor = cFarbeEin
  If PosW < TurmPosition Then
    ft.SetMotor cRTurmMotor, cRTurmRechts
    ft.WaitForChange cRTurmImpuls, TurmPosition - PosW, cRTurmEnde
  Else
    ft.SetMotor cRTurmMotor, cRTurmLinks
    ft.WaitForChange cRTurmImpuls, PosW - TurmPosition
  End If
  TurmPosition = PosW
  ft.SetMotor cRTurmMotor, cRAus
  mf!lblTAction = Format(TurmPosition, "000")
  mf!lblTAction.BackColor = cFarbeAusH
  
End Sub


Public Sub RobotDemo()

' --- Demo Programm fr Robot91 : einfacher Bewegungszyklus Hole - Bringe
'     nach Profi-Robot
  
  mf!lblStatus = "Robot91 fhrt auf Grundstellung"

  InitM
  Do
    Hole HolePositionD
    Bringe BringePositionD
  Loop While WiederholenD
  
  ft.ClearMotors
  mf!lblStatus = "Robot91 Demo beendet"
  
End Sub

Private Sub Senken(Aab%)

' --- Senken des Arm auf "Verdacht" : Anzahl Impulse cRArmSCnt ---

  mf!lblAAction = "senkt"
  mf!lblAAction.BackColor = cFarbeEin
  ft.SetMotor cRArmMotor, cRArmAb
  ft.WaitForChange cRArmImpuls, Aab
  ft.SetMotor cRArmMotor, cRAus
  ArmPosition = ArmPosition + Aab
  mf!lblAAction = Format(ArmPosition, "000")
  mf!lblAAction.BackColor = cFarbeAusH
  
End Sub


